/*
          ,            ?
               .
        .

      z0mbie  .
*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#pragma hdrstop

#pragma pack(push)
#pragma pack(1)

typedef struct BMP_HEADER_STRUCT
{
  WORD  bmp_id;             // 00 01
  DWORD bmp_filesize;       // 02 03 04 05
  DWORD bmp_reserved;       // 06 07 08 09
  DWORD bmp_datapos;        // 0A 0B 0C 0D
  DWORD bmp_bisize;         // 0E 0F 10 11
  DWORD bmp_xsize;          // 12 13 14 15
  DWORD bmp_ysize;          // 16 17 18 19
  WORD  bmp_planes;         // 1A 1B
  WORD  bmp_bits;           // 1C 1D
  DWORD bmp_compression;    // 1E 1F 20 21
  DWORD bmp_imagesize;      // 22 23 24 25
  DWORD bmp_xpelspermeter;  // 26 27 28 29
  DWORD bmp_ypelspermeter;  // 2A 2B 2C 2D
  DWORD bmp_clrused;        // 2E 2F 30 31
  DWORD bmp_clrimportant;   // 32 33 34 35
} BMP_HEADER;

#pragma pack(pop)

int *mtx(int dim, int *array);
int *mtx2(int dim, int *array);
int *mtx3(int dim, int k, int *array);

#define MAXY     5000
#define MAXX     MAXY

int realshit[MAXY][MAXX];

void main(int argc, char* argv[])
{
    int *shit = &realshit[0][0];
    unsigned int b,c;
    unsigned int layer;
    unsigned long x,y;
    int max_value = 1;
    BMP_HEADER h;
    FILE*f=fopen("whatever.bmp","wb");

    if(argc < 3) { printf("Syntax: %s <radix> <layer>\n", argv[0]); exit(0); }
    
    b = atoi(argv[1]);
    if((b < 2) || (b >=MAXX)) { printf("Radix must be between 2 and %d.\n", MAXX); exit(0); }
    layer = atoi(argv[2]);
    if(layer >= b) { printf("Layer must be less than radix.\n"); exit(0); }

    if((mtx3(b, layer, shit)) == NULL) { printf("Can't create matrix.\n"); exit(0); }

    for(y=0; y<b; y++)
    for(x=0; x<b; x++)
      max_value = realshit[y][x] > max_value ? realshit[y][x] : max_value;

    memset(&h, 0x00, sizeof(h));
    h.bmp_id = 'BM';
    h.bmp_bisize = 0x28;
    h.bmp_xsize = b;
    h.bmp_ysize = b;
    h.bmp_planes = 1;
    h.bmp_bits = 24;
    h.bmp_imagesize  = ((h.bmp_xsize *3 + 3) & (~3)) * h.bmp_ysize;
    h.bmp_datapos = sizeof(h);
    h.bmp_filesize = h.bmp_datapos + h.bmp_imagesize;

    assert(f);
    fwrite(&h,1,sizeof(h),f);
    for(y=0; y < h.bmp_ysize; y++)
    {
      static BYTE xxx[MAXX*3+4];
      for(x=0; x < h.bmp_xsize; x++)
      {
        c = shit[y * (b-1) + x];
        c = c * 255 / max_value; // normalize
        xxx[x*3+0] = c;
        xxx[x*3+1] = c;
        xxx[x*3+2] = c;
      }//for x
      fwrite(xxx,1,(b*3+3)&(~3),f);
    }//for y
    fclose(f);

}


//-------------------------------------------------------------------------------
/*
               
     :           
    (F  ,  9    )    
       (,            int).
    ,    ,     
         1.           .
     ,     ,    
        .
    
    :
        ,    .    
    .         111111111  (  ) 
    ,  222222222   :

    111111111 / 9 = 12345679  \           1 2 3 4 5 6 7 9
    222222222 / 9 = 24691358   \          2 4 6 9 1 3 5 8
    333333333 / 9 = 37037037    \         3 7 0 3 7 0 3 7
    444444444 / 9 = 49382716     \____    4 9 3 8 2 7 1 6
    555555555 / 9 = 61728395     /        6 1 7 2 8 3 9 5
    666666666 / 9 = 74074074    /         7 4 0 7 4 0 7 4
    777777777 / 9 = 86419753   /          8 6 4 1 9 7 5 3
    888888888 / 9 = 98765432  /           9 8 7 6 5 4 3 2

     999999999   ,     == 111111111.
     ,      .
     :
       b.       1 
    b-1  0.     
    {x / x = n*(b^(0) + b^(1) + b^(2) + ... + b^(b-2)) && n  [1;b-2]}
       b-1       .
*/

int *mtx(int dim, int *array)
{
    const unsigned int max_dec=10;  //   ,   
    unsigned limit;   //  
    unsigned pos;     //  
    unsigned row;     // 
    unsigned col;     //  (  - )
    unsigned num;     // 
    unsigned mod;     //   

    if(dim < 3) return NULL;   //   
    limit = dim - 1;
    for(row = 1; row < limit; row++)  //   
    {
        pos = 1;    //.  
        num = row;  //- 
        col = 0;
        while(pos <= (limit + max_dec))  //    
        {
            if(num < limit) //    
            {
                num = num * dim + row;  //  
                if((col != 0) && (num < limit))  //    ,   0
                {
                    array[(row - 1) * (dim - 2) + col++] = 0;
                    pos++;   // 
                }
                continue;
            }
            pos++;    // 
            array[(row - 1) * (dim - 2) + col++] = num / limit;     // .  
            if(((mod = num % limit) == 0) && (pos >= limit)) break; // =0    ,  
            num = mod;   //       
        }
    }
    return array;
}

//-------------------------------------------------------------------------------
/*
          ,           ,       
          ,    
       .
    ,      .
*/
int *mtx2(int dim, int *array)
{
    int i, j, base=dim;

    for(i=1;i<=(base-1);i++)
        for(j=1;j<=(base-1);j++) 
            array[(i-1)*(base-1)+j-1] = (i*j) % base;
    return array;
}

//-------------------------------------------------------------------------------
/*
          ,           
    ,       ,   
    :
    1 2 3 4 5 6 7 8 9
       ,   "".
*/
int *mtx3(int dim, int k, int *array)
{
    int i, j, base=dim;

    for(i=1;i<=(base-1);i++)
        for(j=1;j<=(base-1);j++) 
            array[(i-1)*(base-1)+j-1] = ( ( (i * k) % base ) * j ) % base;
    return array;
}